package packageA.B;


import java.io.File;

import javax.swing.JOptionPane;





import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jface.action.IAction;
import org.eclipse.ocl.examples.pivot.ExpressionInOCL;
import org.eclipse.ocl.examples.pivot.resource.*;
import org.eclipse.ocl.examples.pivot.OCL;
import org.eclipse.ocl.examples.pivot.ParserException;
import org.eclipse.ocl.examples.pivot.helper.OCLHelper;
import org.eclipse.ocl.examples.pivot.manager.MetaModelManager;
import org.eclipse.ocl.examples.pivot.model.OCLstdlib;
import org.eclipse.ocl.examples.pivot.uml.UML2Pivot;
import org.eclipse.ocl.examples.pivot.utilities.PivotEnvironment;
import org.eclipse.ocl.examples.pivot.utilities.PivotEnvironmentFactory;
import org.eclipse.ocl.examples.pivot.utilities.PivotUtil;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.resources.util.UMLResourcesUtil;
import org.eclipse.ocl.examples.pivot.delegate.*;

import java.io.File;
import java.io.ObjectInputStream.GetField;
import java.net.URISyntaxException;

import javax.swing.JOptionPane;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.resources.util.UMLResourcesUtil;


import org.eclipse.ocl.examples.xtext.completeocl.*;
import org.eclipse.ocl.examples.xtext.essentialocl.*;

import org.eclipse.ocl.examples.xtext.oclstdlib.OCLstdlibStandaloneSetup;
import org.eclipse.ocl.examples.*;
//import org.eclipse.ocl.examples.
import org.eclipse.ocl.examples.pivot.PivotStandaloneSetup;
//import org.eclipse.ocl.examples.xtext.oclstdlib.

/*org.eclipse.ocl.examples.pivot.uml.UML2Pivot.initialize(resourceSet);
org.eclipse.ocl.examples.pivot.model.OCLstdlib.install();
org.eclipse.ocl.examples.pivot.delegate.OCLDelegateDomain.initialize(resourceSet);
org.eclipse.ocl.examples.completeocl.CompleteOCLStandaloneSetup.doSetup();
org.eclipse.ocl.examples.oclinecore.OCLinEcoreStandaloneSetup.doSetup()
org.eclipse.ocl.examples.oclstdlib.OCLstdlibStandaloneSetup.doSetup()
org.eclipse.ocl.examples.domain.utilities.StandaloneProjectMap.getAdapter(resourceSet);



*/

import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EValidator;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.ocl.examples.pivot.delegate.OCLDelegateDomain;
import org.eclipse.ocl.examples.pivot.delegate.OCLInvocationDelegateFactory;
import org.eclipse.ocl.examples.pivot.delegate.OCLSettingDelegateFactory;
import org.eclipse.ocl.examples.pivot.delegate.OCLValidationDelegateFactory;
import org.eclipse.ocl.examples.pivot.model.OCLstdlib;
import org.eclipse.ocl.examples.pivot.uml.UML2Pivot;
import org.eclipse.ocl.examples.xtext.oclinecore.OCLinEcoreStandaloneSetup;

import com.google.inject.binder.*;

public class Second {
	
	
	
		
	
	
	///////////////////////////////////////////////////////////
	
	
	public void validate(Model model) {

		
		CompleteOCLStandaloneSetup.doSetup();
		OCLstdlibStandaloneSetup.doSetup();
		EssentialOCLStandaloneSetup.doSetup();
		OCLstdlib.install();	
		
		
		final Model myModel = model;

		
		//set up the required pivot/metamodel/model/OCL environment
        ResourceSet resourceSet = new ResourceSetImpl();
     

        org.eclipse.ocl.uml.OCL.initialize(null);
        org.eclipse.ocl.examples.pivot.OCL.initialize(null);
        org.eclipse.ocl.examples.pivot.uml.UML2Pivot.initialize(resourceSet);
        String oclDelegateURI2 = OCLDelegateDomain.OCL_DELEGATE_URI_PIVOT;	
        EOperation.Internal.InvocationDelegate.Factory.Registry.INSTANCE.put(oclDelegateURI2,
        new OCLInvocationDelegateFactory.Global());
        EStructuralFeature.Internal.SettingDelegate.Factory.Registry.INSTANCE.put(oclDelegateURI2,
        new OCLSettingDelegateFactory.Global());
        EValidator.ValidationDelegate.Registry.INSTANCE.put(oclDelegateURI2,
        new OCLValidationDelegateFactory.Global());
        		
        Resource resource = resourceSet.getResource(myModel.eResource().getURI(), true);  
        
   
                
        MetaModelManager metaModelManager = PivotUtil.getMetaModelManager(resource); 
        PivotEnvironmentFactory envFactory = new PivotEnvironmentFactory(null, metaModelManager);
        PivotEnvironment environment = envFactory.createEnvironment();                                    
        OCL ocl = OCL.newInstance(environment);
        
		EList<Constraint> constraints = new BasicEList<Constraint>(myModel.getOwnedRules());
		                           
		// Get all OCL rules from the model
		getOCLRulesFromModel(myModel, constraints);
		                           
		// Get all OCL rules from the profiles applied to the model
		getOCLRulesFromAppliedProfiles(myModel, constraints);
		
		
		//Now that we have all the constrains see if any are violated in the model
	
		
  		for (Constraint constraint : constraints) {
  			
  			
  			String expression = getOCLExpressionFromConstraint(constraint);
  			System.out.println("expression:"+expression);
			//loop over the elements the constraint constrains
  			final EList<Element> ceList = constraint.getConstrainedElements();  
  			
  			for(Element ce : ceList)
  			{
  				
  				OCLHelper oclHelper = null;
  				
  				//stereotypes must be handled specially
                if(ce instanceof Stereotype)
                {
                	//look for all the elements in the model that have the stereotype applied
                	final EList<Element> oeList = myModel.allOwnedElements();
                	for(Element oe : oeList)
          			{
                		if(oe.isStereotypeApplied((Stereotype)ce))
                		{;
                        	final EList<EObject> saList = oe.getStereotypeApplications();
                        	for(EObject sa : saList)
                  			{
                           		//make the EObject work with the Pivot concept i.e. so the stereotype properties are available
                        		org.eclipse.ocl.examples.pivot.Element psa= null;
                        		System.out.println("sa: " +sa);
                        		
                        		try
           		               	{
                        			
                        			psa = UML2Pivot.importFromUML(metaModelManager, "xx", sa);
                        			System.out.println("psa: " + psa);
                        		
        	             		}
                        		catch(Exception e)
           		               	{
           		               		e.printStackTrace();
           		               	}
                        		if(psa != null)
                        		{
                        			 oclHelper = ocl.createOCLHelper(psa);
                        			//finally let's run the OCL!!
                        		
                        			evaluateOCL(ocl,oclHelper,expression,psa);    
                        			
                        		
                      		  	
                        		}
                  			}
                		}
          			}
                }
                else
                {
                	 oclHelper = ocl.createOCLHelper(ce);
      		         oclHelper.setContext(ce.eClass());
      		 
      		       
      		         evaluateOCL(ocl,oclHelper,expression,ce);    
      		        
                }       
  			}
  		}
  		
  	
  		
  		
	}

	private EList<Constraint> getOCLRulesFromAppliedProfiles(Model myModel, EList<Constraint> constraints)
	{
		for(Profile profile : myModel.getAllAppliedProfiles()){
			
		final TreeIterator<EObject> profileIterator = profile.eAllContents();
		       while(profileIterator.hasNext()){
		              EObject tempObject = profileIterator.next();
		                                         
		              if (tempObject instanceof NamedElement) {
		                     NamedElement ne = (NamedElement) tempObject;
		                                                
		                     if(ne.getNamespace() != null) {
		                     final EList<Constraint> temp = ne.getNamespace().getOwnedRules();
		                                  
		                         if(!constraints.containsAll(temp)){
		                             constraints.addAll(temp);
		                            
		                         }
		                     }
		              }
		       }      
		}
		return constraints;
	}
	
	private EList<Constraint> getOCLRulesFromModel(Model myModel, EList<Constraint> constraints)
	{
		final TreeIterator<EObject> iterator = myModel.eAllContents();
		
		while(iterator.hasNext()){
		       EObject tempObject = iterator.next();
		                                  
		       if (tempObject instanceof NamedElement) {
		              NamedElement ne = (NamedElement) tempObject;
		                                         
		              if(ne.getNamespace() != null) {
		                     final EList<Constraint> temp = ne.getNamespace().getOwnedRules();
		                                                
		                     if(!constraints.containsAll(temp)){
		                           constraints.addAll(temp);
		                     }
		              }
		       }
		}
		return constraints;
	}
	
	private String getOCLExpressionFromConstraint(Constraint constraint)
	{
		if (constraint.getSpecification() instanceof OpaqueExpression) {
				OpaqueExpression opaqueExpression = ((OpaqueExpression) constraint.getSpecification());

				// Find the body named OCL
			    int indexOfOCLBody = -1;
			    for (int i = 0; i < opaqueExpression.getLanguages().size() && indexOfOCLBody == -1; i++) {
			    	if (opaqueExpression.getLanguages().get(i).equals("OCL")) {
			    		indexOfOCLBody = i;
			        }
			    }
			                                         
			    // If the body was found, continue the check
			    if (indexOfOCLBody != -1) {
			    	return opaqueExpression.getBodies().get(indexOfOCLBody);
			    }
			}	
		return null;//there was no proper OCL to be found
	}
	
	private void evaluateOCL(OCL ocl,OCLHelper oclHelper,String expression, Object context)
	{
		 try {
				
          	// Turn the expression into a query and evaluate it
          	ExpressionInOCL createQuery = oclHelper.createQuery(expression);
        	System.out.println("context "+context);
        	System.out.println("create Query: "+createQuery);
          	Object result = ocl.evaluate(context, createQuery);
          	System.out.println("result: "+result);
	             
          } catch (ParserException e) {
	             Diagnostic diagnostic = e.getDiagnostic();
	             System.out.println(diagnostic.getMessage());
          }  
		
		
		
		
		
		
	}
}	
		
		
	/*{	final Model myModel = model;


		EList<Constraint> constraints = new BasicEList<Constraint>(myModel.getOwnedRules());
		                           
		// Get all OCL rules from the model
		final TreeIterator<EObject> iterator = myModel.eAllContents();
		while(iterator.hasNext()){
		       EObject tempObject = iterator.next();
		                                  
		       if (tempObject instanceof NamedElement) {
		              NamedElement ne = (NamedElement) tempObject;
		                                         
		              if(ne.getNamespace() != null) {
		                     final EList<Constraint> temp = ne.getNamespace().getOwnedRules();
		                                                
		                     if(!constraints.containsAll(temp)){
		                           constraints.addAll(temp);
		                     }
		              }
		       }
		}
		                           
		// Get all OCL rules from the profiles applied to the model
		for(Profile profile : myModel.getAllAppliedProfiles()){
		final TreeIterator<EObject> profileIterator = profile.eAllContents();
		       while(profileIterator.hasNext()){
		              EObject tempObject = profileIterator.next();
		                                         
		              if (tempObject instanceof NamedElement) {
		                     NamedElement ne = (NamedElement) tempObject;
		                                                
		                     if(ne.getNamespace() != null) {
		                     final EList<Constraint> temp = ne.getNamespace().getOwnedRules();
		                                  
		                         if(!constraints.containsAll(temp)){
		                             constraints.addAll(temp);
		                         }
		                     }
		              }
		       }      
		}

		// Check if any OCL constraint is violated
		for (Constraint constraint : constraints) {
		    String constraintName = constraint.getName();
		                                  
		    if (constraint.getSpecification() instanceof OpaqueExpression) {
		        OpaqueExpression opaqueExpression = ((OpaqueExpression) constraint.getSpecification());

		              // Find the body named OCL
		              int indexOfOCLBody = -1;
		        for (int i = 0; i < opaqueExpression.getLanguages().size() && indexOfOCLBody == -1; i++) {
		            if (opaqueExpression.getLanguages().get(i).equals("OCL")) {
		                indexOfOCLBody = i;
		             }
		         }
		                                         
		    // If the body was found, continue the check
		         if (indexOfOCLBody != -1) {
		             final String expression = opaqueExpression.getBodies().get(indexOfOCLBody);
		             final Namespace contextObject = constraint.getContext();

		             ResourceSet resourceSet = new ResourceSetImpl();
		             Resource resource = resourceSet.getResource(myModel.eResource().getURI(), true);
		                                                
		             MetaModelManager metaModelManager = PivotUtil.getMetaModelManager(resource); 
		             PivotEnvironmentFactory envFactory = new PivotEnvironmentFactory(null, metaModelManager);
		             PivotEnvironment environment = envFactory.createEnvironment();
		                                                
		             OCL.initialize(null);
		                                                
		             OCL ocl = OCL.newInstance(environment);
		             OCLHelper oclHelper = ocl.createOCLHelper(contextObject); 
		                                                                                  
		                                                
		             oclHelper.setContext(contextObject.eClass());
		             try {
		             // Turn the expression into a query and evaluate it
		             ExpressionInOCL createQuery = oclHelper.createQuery(expression);
		             Object result = ocl.evaluate(contextObject, createQuery);
		             } catch (ParserException e) {
		             Diagnostic diagnostic = e.getDiagnostic();
		             System.out.println(diagnostic.getMessage());
		             }
		         }
		       }
		    }
		}

} */
